import os,time,re
import libConst as LC
from UserList import UserList

"""
This module contains new functions for os, file, directories manipulation and selection
"""

#Here are one time computed infos
LocalSep=os.sep

def prepPath(file,base=LocalSep,list=0):
    """
    PREParePATH
    Simply exec a join, normpath, abspath, summing his args.
    arguments: file, base dir, list 
    joining: base dir + file if list is false
    joining: base dir + file[0]+...+file[n] if list is true
    If the third one is true (a python true), the 2nd argument will be trated as a list, default is 0 (false)
    Return an absolute path as string
    """
   # print file, base
    if list:
        tmpArr=file
        file=""
        for x in xrange(len(tmpArr)-1):
            file=os.path.join(file,tmpArr[x])
    return (os.path.normpath(os.path.join(base,file)))

def mkdirR(dir):
    """
    MaKeDIRectorieRecursively
    SomeTimes we needs to build directories tree this's the soluction.
    This function accept the path of the directory to be build, even as relative and absolute, all paths will be converted to absolute.
    It's not necessary that the directory doesn't exists.
    """
    firArr=dir.split(LocalSep)
    for el in xrange(1,len(firArr)+1):
        PathFrame=(LocalSep).join(firArr[:el])+LocalSep
        if not os.path.exists(PathFrame):
           # print 'created: ', PathFrame
            os.mkdir(PathFrame)
    print "Created directory: ", PathFrame


class filer(UserList):
    """
    This class perform file and directory selection based on criteria.
    It's a list, but be aware, this list is intended only to be a stream of data,
    so filtering is never performed on the whole list in one time; it filter only
    the min. to return correct information.
    criteria: [[excludeDir,yDate=date,hash(via sha)=previousShaFile|1,method=and(1)|or(0)],[here file extensions]]
              [[1,18/05/04 18:03,0,1],['.html','.py','.mp.+?']] #remember the dot
    """
    def __init__(self,fileList,baseDir,criteria,filterNow=0):
        UserList.__init__(self,fileList)
        #Setting up operator for filtering
        if criteria[0][3]:
            self.operator=self.__wrapAND
        else:
            self.operator=self.__wrapOR
        
        #Global variables
        self.BaseDir=baseDir
        self.lastgetitemcall=0
        self.criteria=criteria
        
        if filterNow:
            pass   
    
    def Filter(self,el,bDir):
        #this value must be an identity value for the selected joining method
        result=self.criteria[0][3]
        thisFile=prepPath(el,bDir)
        #print thisFile
        
        #Exclude directory and not regular files
        if self.criteria[0][0]:
            result=self.operator(result,os.path.isfile(thisFile))
        #print "1",
        #Exclude by date selection
        if self.criteria[0][1] and self.operator(1,result):
            result=self.operator(result,(time.mktime(time.strptime(self.criteria[0][1],LC.timeFormat))<os.stat(thisFile)[8]))
        
        #Excluing via hash has to be done
        
        #Exclude by extension
        ok=0
        if self.operator(1,result):
            
            for ext in self.criteria[1]:
                if re.search(ext,el):
                    ok=1
                    break
        result=self.operator(result,ok)
        
        #And now the end
        return result
        
    def __wrapOR(self,a,b):
        return (a or b)
    def __wrapAND(self,a,b):
        return (a and b)
    def __getitem__(self,i):
        #This should raise an IndexError to stop iterations over the class
        self.data[self.lastgetitemcall]
       
        #This is the main part
        for el in self.data[self.lastgetitemcall:]:
            self.lastgetitemcall+=1
            if self.Filter(el,self.BaseDir):
                return el
        
        #This is just a fix, if the last call is possible, but none element pass the Filter, we reached the end of the list
        raise IndexError
