#!/usr/bin/python
#-*- coding: utf-8 -*-
"""
CHANGE LOG
    DATE 17 02 2005
    Version 0.17
    ObliVio is going to shape as I projected.
    This version descend directly from 0.15, the version 0.16 was too slow.
    This time I added a the possibility to analyze any kind of document, the program
    check and prepare a dict associating the file extension with the specific class
    that must elaborate it, simply if an extension has not a class it's joined
    with a generic class.
    To make new class:
    class FILEEXTPage(BaseFile):
        def InIt(self,relUrl):
            BaseFile.InIt(relUrl)
            --------------
            ---------
            -----------
        def Write(self):
            return <page WHATYOUWANT ></page>
    BaseFile is a basical class for file analisys, look at the code.
    you are free to don't use it in your class.
    I'm stil developping under Python 2.3.4!
    
    DATE 23 10 2004
    version 0.13
    more pythonic code
    preparing for subclassing structure of file analisys
    preparing for extensible structure
    next step:
	-for file analisys there will be a superclass providing uniform and simple file statistics. All other classes providing file analisys must subclass this one.
	each class is associated to file extension (or MIME-type) so when Oblivio found a file if its extension is in filExt, it will call the respective class
	passing inly absolute file path and name. That class must provide of a Write() method to return data. 
	No other output formats are planned for Oblivio, so Write() method should be very easier to be coded.
	If no class can handle that type, Oblivio call the superclass.
    DATE: 5 10 2004
    time format, tidy, empty dirs skipping is easier to conf.
    file stats via os.stat().
    elapsed time is the same, even if there are more operations.
    file size now is a float.
    DATE: 4 10 2004
    added features:
	None
    changes
        Rewritten file exclusion code and a lot of code relative to absolute and relative file, reduced redundant code in class page.__init__
	It should be faster.
    DATE: 2 10 2004
    added features:
        Directory exclusion
        file exclusion
    DATE:29  9 2004
    added features:
        statistics:
            elaboration time
            max file size
            min file size
            medium file size
            total files size
    prepared basic xsl stylesheet for xml output.
    Now it can be read also by humans >:->
    Fixed a bug in class page, relUrl was wrong and returned a bad url. Now it's correct.

    Date:26 9 2004
    Added features:
        skip empty directories
        analisys of page structure via H[1-6] tags
"""
import os, string, copy, re, time, sys
import libWrap
import libMarkup
conf_dict={\
    'skipDirs':(r'/image',r'/cvs',r'/*_files', r'/Orig_templates'), \
    'excludeFiles':(r'/report.html',r'/LinkVer_report.html'),\
    'filExt':('pdf','htm','html'),\
    'excludeEmpty':1,   \
    'timeFormat':"%d %b %y, %H:%M:%S",\
    'stat':1,\
    'openMap':0,\
    'readTidyOutput':1,\
    'starTidy':1,\
    'tidy':(r'tidy',os.curdir + r'/Orig_templates/xml.tidy'),\
    'output1line':'<?xml version="1.0"?>\n<?xml-stylesheet type="text/xml" href="xx.xml"?>\n<root>',\
    'plugIns_dir':r'\Obl_plug-ins',\
    'root': os.curdir,\
    'dest':'mappe/map.xml',\
    'FullCnt':1\
}
skipDirs=conf_dict['skipDirs']
excludeFiles=conf_dict['excludeFiles']
filExt=conf_dict['filExt']
excludeEmpty=conf_dict['excludeEmpty']
timeFormat=conf_dict['timeFormat']
stat=conf_dict['stat']
openMap=conf_dict['openMap']
readTidyOutput=conf_dict['readTidyOutput']
starTidy=conf_dict['starTidy']
tidy=conf_dict['tidy']
output1line=conf_dict['output1line']
plugIns_dir=conf_dict['plugIns_dir']
root=conf_dict['root']
dest=conf_dict['dest']
FullCnt=conf_dict['FullCnt']

if root=='': root=os.path.abspath(os.getcwd());
os.chdir(root)
if dest=='': dest=os.path.join(root,'map.xml');
pollo=[]
pollo.append(output1line)
file_number=[]
#classes={}

class BaseFile:
    def InIt(self,relUrl):
        pagStats=os.stat(relUrl)
        self.pagLastM=time.strftime(timeFormat,time.gmtime(pagStats[8]))
        self.pagSizeByte=pagStats[6]/1024.00
class WhatFilePage(BaseFile):
    def InIt(self,relUrl):
        self.relUrl=relUrl
        BaseFile.InIt(self,relUrl)
    def Write(self):
        return '<page date="%s" size="%.2f Kb" description="Some Kind of Document" title="%s" url="%s"></page>\n' % (self.pagLastM, self.pagSizeByte, os.path.splitext(os.path.basename(self.relUrl))[0], self.relUrl[2:])
class MP3Page(BaseFile):
    def InIt(self,relUrl):
        BaseFile.InIt(self,relUrl)
        "store ID3v1.0 MP3 tags"
        tagDataMap = {"title" : ( 3, 33, stripnulls),
                            "artist" : ( 33, 63, stripnulls),
                            "album" : ( 63, 93, stripnulls),
                            "year" : ( 93, 97, stripnulls),
                            "comment" : ( 97, 126, stripnulls),
                            "genre" : (127, 128, ord)}
        tagsValue=[6]
        def stripnulls(data):
            "strip whitespace and nulls"
            return data.replace("\00", "").strip()
        def parse(self, filename):
            "parse ID3v1.0 tags from MP3 file"
            self.clear()
            try:
                fsock = open(filename, "rb", 0)
                try:
                    fsock.seek(128, 2)
                    tagdata = fsock.read(128)
                finally:
                    fsock.close()
                if tagdata[:3] == "TAG":
                    i=0
                    for tag, (start, end, parseFunc) in self.tagDataMap.items():
                        tagsValue[i] = parseFunc(tagdata[start:end])
                        i+=1
            except IOError:
                pass
        parse(self, relUrl)
    def Write(self):
        return '<page description="title:%s, artist:%s, album:%s, year:%s, commenrt:%s, genre:%s"/>\n' % (tagsValue[0], tagsValue[1],tagsValue[2],tagsValue[3],tagsValue[4],tagsValue[5])

class HTMLPage(BaseFile):
    def InIt(self,relUrl):
        #import htmlentitydefs as H
        """
        Now it may not seem useful, when I will insert more options such as reordening by rel or rev, it wil be more usefull.
        __init__ takes only absolute and relative path, after he reads the file and extracts informations.
        """
        BaseFile.InIt(self, relUrl)
        self.HTML_code=re.sub('\r+','',re.sub('\s+',' ',re.sub('\n','',open(relUrl,"r").read())))
        self.PAGE_struct=''
        descrMeta=re.compile(r'(?<=[<]meta name="%s" content=")(.+?)(?=")>' % 'description',re.I|re.L|re.S|re.U)
        titleTag=re.compile(r'(?<=[<]title[>])(.+?)(?=[<]/title[>])',re.I|re.L|re.S|re.U)
        aNext=re.compile(r'<a[^>]+?(?<=rel="next")[^<]+?(?<=href=")(.+?)(?=").+?>',re.I|re.L|re.S|re.U)
        Hn=(r'<(h[1-6])>(.+?)</\1>',(r'<.+?>',''))
        try:
            #self.pagDescr=re.search(descrMeta,self.HTML_code,re.I|re.L|re.S|re.U).group(1)
            self.pagDescr=descrMeta.search(self.HTML_code).group(1)
        except AttributeError:
            self.pagDescr=""
        self.pagDescr=re.sub('"',"'",self.pagDescr)
        #~ for el in H.entitydefs.keys():
            #~ print el
            #~ self.pagDescr=self.pagDescr.replace('&'+el,H.entitydefs[el])
        try:
            #self.pagTitle=re.search(titleTag,self.HTML_code,re.I|re.L|re.S|re.U).group(1)
            self.pagTitle=titleTag.search(self.HTML_code).group(1)
        except:
            self.pagTitle=self.relUrl
        self.pagTitle=re.sub('"',"'",self.pagTitle)
        try:
            #self.pagNext=re.search(aNext,self.HTML_code,re.I|re.L|re.S|re.U).group(1)
            self.pagNext=aNext.search(self.HTML_code).group(1)
        except AttributeError:                                                                  #
            self.pagNext=""                                                                 #
        self.pagNext=re.sub('"',"'",self.pagNext)                                               #
        self.pagRelUrl=string.replace(relUrl[2:],'\\','/')
        Hn_re=re.compile(Hn[0],re.I|re.L|re.S|re.U)
        
        for el in Hn_re.finditer(self.HTML_code):
            self.PAGE_struct=self.PAGE_struct+ '\n<hn value="%s" lvl="%s" />' % (re.sub(Hn[1][0],Hn[1][1],el.group(2)),el.group(1))
        #print self.PAGE_struct
        #for el in (self.pagDescr,self.pagTitle,self.PAGE_struct):         
    def Write(self):
        return '<page date="%s" size="%.2f Kb" description="%s" title="%s" next="%s" url="%s">\n %s \n</page>\n' % (self.pagLastM,self.pagSizeByte,self.pagDescr,self.pagTitle,self.pagNext,self.pagRelUrl,self.PAGE_struct)

class HTMPage(BaseFile,HTMLPage):
    def InIt(self,relUrl):
        HTMLPage.InIt(self,relUrl)

class PYPage(BaseFile):
    def InIt(self,relUrl):
        self.relUrl=relUrl
        BaseFile.InIt(self,relUrl)
        #~ print '\n', os.path.basename(relUrl)
        #~ sys.path.append(os.path.dirname(relUrl))
        #~ self.relModule=__import__(os.path.splitext(os.path.basename(relUrl))[0])
        #~ self.pyDoc=self.relModule.__doc__
    def Write(self):
        #~ print '<page date="%s" size="%.2f Kb" description="Python Document" title="%s" url="%s"></page>\n' % (self.pagLastM, self.pagSizeByte, os.path.splitext(os.path.basename(self.relUrl))[0],self.relUrl)
        return '<page date="%s" size="%.2f Kb" description="Python Document" title="%s" url="%s"></page>\n' % (self.pagLastM, self.pagSizeByte, os.path.splitext(os.path.basename(self.relUrl))[0], self.relUrl[2:])
        
        

def print_to_file(var):
    pollo.append(libMarkup.string2validXML(var))
    #print var
TAG_lst=[] ##contasins opened tags name, when closed they are removed.

def scrivi(uno,dirname,files):
    print '.',
    def calc_level(path):
        return path.count(os.sep)+1
    def amIinList(list,string):
        
        """
        PROBLEM:
        'imag' in ['images','idic'] returns True; 'images\ert' in ['images','idic'] returns False.
        So we reverse the relation for each element in the list we evaluate if it's in the string.
        if last char of el is '*' => first expression depends on (inwhat in I) so if it's true, its value is returned 
        ([1 or x=1]or is always true so it's not evaluated)
        Simplier if el[-1:]=='*' we compare string into the list. It allow to specific to exclude simple dirs(*) or full dir trees.
        else (el in inwhat) is evaluated and return its value.
        if char is not '*' and operator is always false, but or may be true too, so last expression is evaluated.
         (el[-1:]=='*' and (el in list)) or (el in string):
        """
        for el in list:
            
            if re.search(el.replace('*','.+?'),string):
                return True
        return False
    
    def chekObj(str):
        """
        ritorna vero se la stringa non corrisponde a directory, link, file con estensione diversa da filExt o con nome uguale a excludeFiles
        """
        fileRel=os.path.join(dirname,str)
        if not(os.path.isdir(fileRel) or os.path.islink(fileRel) or (fileRel[1:] in excludeFiles)) and (os.path.splitext(str)[1][1:] in filExt):
                return 1

    if amIinList(skipDirs,dirname[1:]):
        return
    names=filter(chekObj,files)
    if len(names)==0 and excludeEmpty: return;

    tmp=dirname[1:]+os.sep
    livello=calc_level(dirname)
    TAG_rmv=[]
    
    if not len(TAG_lst)==0:
        TAG_rmv=copy.copy(TAG_lst)
        TAG_rmv.reverse()
        for dir in TAG_rmv:
            if not(os.sep+dir+os.sep in dirname[1:]):
                print_to_file("</dir>")
                TAG_lst.remove(dir)
    for i in range(0,livello):
        tag_name=tmp[:tmp.find(os.sep)]
        if TAG_lst.count(tag_name)==0 and not (tag_name==""):
            TAG_lst.append(tag_name)
            print_to_file('<dir name="'+TAG_lst[TAG_lst.index(tag_name)]+'">')
        tmp=tmp[tmp.find(os.sep)+1:]
    
    #~ HTML=HTMLPage()
    #~ print HTML
    #~ HTM=HTMLPage()
    #~ PY=PYPage()
    for el in names:
        #classes[os.path.splitext(el)[1][1:]+'Page'].InIt(os.path.join(dirname,el))
        #~ if os.path.splitext(el)[1][1:].upper()=='PY':page=PY;
        #~ if os.path.splitext(el)[1][1:].upper()=='HTML':page=HTML;
        #~ if os.path.splitext(el)[1][1:].upper()=='HTM':page=HTML;
        page=plugIns[os.path.splitext(el)[1][1:]]()
        #~ print page
        page.InIt(os.path.join(dirname,el))
        file_number.append(page.pagSizeByte)
        print_to_file(page.Write())

def importPlugIns():
    preDict=[]
    module=sys.modules[BaseFile.__module__]
    for el in filExt:
        #~ try:
        #~ print el
        if FullCnt:
            subclass=el.upper()+"Page"
            pl=hasattr(module, subclass) and getattr(module, subclass)  or WhatFilePage
        #~ print pl
        #~ except ImportError:
            #~ pl=__import__('WhatFile')
        preDict.append((el,pl))
    global plugIns
    plugIns=dict(preDict)
    #print plugIns.keys()
    #print plugIns['html']
    #print plugIns
def startMe():
    print os.getcwd()
    start=time.time()
    importPlugIns()
    #for ext in filExt:
      #  classes.append(ext[:2]: ext[:2]+'Page')
    os.path.walk(os.curdir,scrivi,"::")
    total_size=0
    
    for tag_name in TAG_lst:
        print_to_file("</dir>")
    
    if stat:
        for el in file_number:
            total_size=el+total_size
        file_number.sort()
        print_to_file('<stats>\n<elaboration Time="%s s"/>\n<elaboration files="%s"/>\n <elaboration fileSizeTotal="%.4f KB"/>\n<elaboration fileSizeMedium="%.4f KB"/>\n<elaboration fileMinSize="%.4f"/>\n<elaboration fileMaxSize="%.4f"/>\n</stats>\n</root>' % (time.time()-start,len(file_number),total_size, total_size/len(file_number), file_number[0],file_number.pop()))
    print os.getcwd()
    def fil(el):
        import htmlentitydefs as H
        #el=el.replace('&','&#38;')
        #~ for el in H.entitydefs.keys():
            #~ el=el.replace('&'+el, '&'+H.entitydefs[el])
        return el

    open(dest,"w").writelines(map(fil,pollo))
    
    if starTidy:
        ted=os.popen3(tidy[0] +' -config '+ tidy[1]+' -m "'+dest+'"')
        if readTidyOutput: print ted[2].read();
    if openMap: os.startfile(dest);
    #print str((time.time()-start)*1000) + ' ms'
    print('\n')
    print total_size,' kb'

def usage():
    print 'zzzzzzz...'

def printConf():
    pass

if __name__=='__main__':
    import sys
    try:
        if sys.argv[1]=='-u':
            userInterface()
        elif sys.argv[1]=='-h':
            usage()
        else:
            printConf()
            if raw_input('Continue?y/n')=='y':
                startMe()
            else:
                sys.exit()
    except IndexError:
        startMe()
    #~ raw_input('>>>')
